dofile("scripts/base/util.lua")

if can_read_state() ~= "yes" then
	return text
end

--~ print("automate.lua: ", path)

params = parse_params(params)

if path == "/custom-automate-page" then
	print("params", params)
end

--~ got uri: /inventory.php | ?which=2&action=message (from /inv_equip.php?action=customoutfit&outfitname=kolproxy+backup), size 85883
--~ got uri: /charpane.php |  (from /charpane.php), size 9442
--~ got uri: /account_manageoutfits.php |  (from /account_manageoutfits.php), size 1353
--~ posting page /account_manageoutfits.php params: Just [("action","Yep."),("name2","kolproxy backup"),("delete2","on")]

if path == "/lair6.php" then
	if params.place == "0" then
		if string.match(text, "At the top of the steps leading to the Sorceress' Chamber, you encounter two doors.") then
			code = set_ascension_state("zone.lair.doorcode", "")
			post_page("/lair6.php", { preaction = "lightdoor" })
			code = get_ascension_state("zone.lair.doorcode")
			print("lair6 code", code, "params", table_to_str(params))
			if code ~= "" then
				text = post_page("/lair6.php", { action = "doorcode", code = code })
			end
		end
	end
	if params.place == "3" or params.place == "4" then
		if get_session_state("lair6.familiar.requesting") == "" then
			if string.match(text, "Disappointed by your failure, you stomp off in a huff, and stub your toe.") then
				which = string.match(text, [[<img src="http://images.kingdomofloathing.com/adventureimages/([a-z]+).gif" width=100 height=100>]])
				print("Sorceress familiar:", which)
				local familiar_lookup = {
					barrrnacle = { id = 4, name = "Angry Goat", },
					goat = { id = 1, name = "Mosquito", },
					lime = { id = 3, name = "Levitating Potato", },
					mosquito = { id = 5, name = "Sabre-Toothed Lime", },
					potato = { id = 8, name = "Barrrnacle", },
				}
				if familiar_lookup[which] then
					status = str_to_table(get_status_info())
					get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(familiar_lookup[which].id) })
					set_session_state("lair6.familiar.need", tostring(familiar_lookup[which].name))
					newstatus = str_to_table(get_status_info())
					newcharpane = str_to_table(get_charpane_info())
					weight = tonumber(string.match(newcharpane["familiar"], [[Just %(%b"",([0-9]+)%)]]))
					if tonumber(newstatus.familiar) == familiar_lookup[which].id then
						if weight and weight >= 20 then
							set_session_state("lair6.familiar.requesting", "active")
							newtext = get_page("/lair6.php", { place = params.place })
							set_session_state("lair6.familiar.requesting", "")
							if string.match(newtext, "You move further into the tower, while huge chunks of stone fall from the walls for no good reason.") then
								set_session_state("lair6.familiar.result", "won")
								text = newtext
								print("Won vs NS familiar")
							else
								set_session_state("lair6.familiar.result", "error")
								text = newtext .. "<br><br>Error, expected to win this fight with a " .. tostring(weight) .. " lb " .. familiar_lookup[which].name .. "."
								print("Error fighting NS familiar")
							end
						else
							set_session_state("lair6.familiar.result", "too low weight")
							print("Familiar weight is only", weight)
						end
					else
						set_session_state("lair6.familiar.result", "missing")
						print("Missing familiar")
					end
					get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = status.familiar })
				else
					print("Unknown NS familiar", which)
				end
			end
		end
	end
end

if path == "/mystic.php" then
	if string.match(text, "Would you like to hear a tale") then
		if get_session_state("mystic.requesting") == "" then
			set_session_state("mystic.requesting", "active")
			post_page("/mystic.php", { action = "crackyes1" })
			post_page("/mystic.php", { action = "crackyes2" })
			text = post_page("/mystic.php", { action = "crackyes3" })
			set_session_state("mystic.requesting", "")
		end
	end
end


--~ >The Oracle speaks:<p>&quot;Your Major Consultation is this:  That plus sign you've been hanging on to?  It's actually a book.  Read it.&quot;<

--~ itemid[818]
--~ got uri: /inv_use.php | ?pwd=060d42221ac94e9d872f39c247195466&which=3&whichitem=818&ajax=1&_=1270355701308 (from /inv_use.php?pwd=060d42221ac94e9d872f39c247195466&which=3&whichitem=818&ajax=1&_=1270355701308), size 1041

function eaten_food(item, usetext)
	for x in (usetext .. "<p><center><b>and then...</b></center></p>"):gmatch("(.-)<p><center><b>and then%.%.%.</b></center></p>") do
		if x:match([[<img src="http://images.kingdomofloathing.com/itemimages/[^"]-%.gif" width=30 height=30>]]) then
			if not x:match(">You're too full to") then
				print("ate food", printstr(item), x)
				if tonumber(item.fullness) then
					increase_daily_counter("fullness", tonumber(item.fullness))
				else
					set_day_state("unknown fullness", "yes")
				end
			end
		end
	end
end

function used_spleen(item, quantity, usetext)
	if not usetext:match("bad for your spleen.  That .- would cause it to rupture.<") then
		print("used spleen", quantity, printstr(item), usetext)
		if tonumber(item.spleen) then
			increase_daily_counter("spleen", tonumber(item.spleen) * quantity)
		else
			set_day_state("unknown spleen", "yes")
		end
	end
end

if path == "/inv_eat.php" then
	local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
	if d.name then
		eaten_food(d, text)
	else
		set_day_state("unknown fullness", "yes")
		local tbl = get_ascension_state("unknown food items eaten")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		table.insert(tbl, params.whichitem)
		set_ascension_state("unknown food items eaten", table_to_str(tbl))
	end
end

--~ posting page /sushi.php params: Just [("action","Yep."),("pwd","bc24379b44f024724b28de075dd2f860"),("whichsushi","5"),("whichtopping","3819"),("whichfilling1","0")]
--~ got uri: /sushi.php |  (from /sushi.php), size 3698

if path == "/inv_use.php" then
	local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
	if d.name then
		if d.spleen then
			local amount = tonumber(params.itemquantity) or 1
			used_spleen(d, amount, text)
		end
	else
		set_day_state("unknown spleen", "yes")
		local tbl = get_ascension_state("unknown spleen items used")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		table.insert(tbl, params.whichitem)
		set_ascension_state("unknown spleen items used", table_to_str(tbl))
	end
end

if path == "/choice.php" then
	if requestpath == "/inv_use.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name == "Orcish Frat House blueprints" then
			local inventory = str_to_table(get_inventory_counts())
			options = {
				[1] = { wearing = { hat = "Orcish baseball cap", weapon = "homoerotic frat-paddle", pants = "Orcish cargo shorts" } },
				[2] = { wearing = { hat = "mullet wig" }, inventory = { name = "briefcase", amount = 1 } },
				[3] = { wearing = { pants = "frilly skirt" }, inventory = { name = "hot wing", amount = 3 } },
			}
			local buyable = { ["frilly skirt"] = true }
			function check_option(tbl, equipment)
				local equipped = true
				local possible = true
				for where, want in pairs(tbl.wearing) do
					local have = equipment[where] and str_to_table(get_item_data_by_id(equipment[where])).name
					if have ~= want then
						equipped = false
						local itemid = tonumber(str_to_table(get_item_data_by_name(want)).id)
						if not (inventory[itemid] or buyable[want]) then possible = false end
					end
				end
				if tbl.inventory then
					local itemid = tonumber(str_to_table(get_item_data_by_name(tbl.inventory.name)).id)
					if not (inventory[itemid] and inventory[itemid] >= tbl.inventory.amount) then
						possible = false
					end
				end
				return possible, equipped
			end
			function equip_for_option(tbl, equipment)
				local changed = {}
				for where, want in pairs(tbl.wearing) do
					local have = equipment[where] and str_to_table(get_item_data_by_id(equipment[where])).name
					if have ~= want then
						local itemid = tonumber(str_to_table(get_item_data_by_name(want)).id)
						if buyable[want] then
							if not inventory[itemid] then
								get_page("/store.php", { phash = params.pwd, buying = "1", whichitem = tostring(itemid), howmany = "1", whichstore = "5", ajax = "1", action = "buyitem" })
							end
						end
						get_page("/inv_equip.php", { pwd = params.pwd, action = "equip", whichitem = tostring(itemid), ajax = "1" })
						changed[where] = equipment[where]
					end
				end
				return changed
			end
			function do_infiltrationist()
				local equipment = str_to_table(str_to_table(get_status_info()).equipment)
				for choicenum, tbl in pairs(options) do
					possible, equipped = check_option(tbl, equipment)
					if possible and equipped then
						text = post_page("/choice.php", { pwd = params.pwd, whichchoice = tostring(188), option = tostring(choicenum)})
						text = text:gsub([[<a href="adventure.php%?snarfblat=27">Adventure Again %(The Orcish Frat House%)</a>]], "")
						return
					end
					if possible then
						print("equip up for", choicenum)
						local changed = equip_for_option(tbl, equipment)
						local newequipment = str_to_table(str_to_table(get_status_info()).equipment)
						possible, equipped = check_option(tbl, newequipment)
						if possible and equipped then
							text = post_page("/choice.php", { pwd = params.pwd, whichchoice = tostring(188), option = tostring(choicenum)})
							text = text:gsub([[<a href="adventure.php%?snarfblat=27">Adventure Again %(The Orcish Frat House%)</a>]], "")
						end
						for x, itemid in pairs(changed) do
							get_page("/inv_equip.php", { pwd = params.pwd, action = "equip", whichitem = tostring(itemid), ajax = "1" })
						end
						return
					end
				end
			end
			do_infiltrationist()
--~ 			post_page("/choice.php", { pwd = params.pwd, whichchoice = 188, option = 3})
		end
	end
end

if path == "/multiuse.php" then
	local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
	if d.name then
		if d.spleen then
			used_spleen(d, tonumber(params.quantity), text)
		end
	else
		set_day_state("unknown spleen", "yes")
	end
end

if path == "/inventory.php" then
	if requestpath == "/inv_eat.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name then
			eaten_food(d, text:match([[<div id="effdiv">.-</div>]]))
		else
			set_day_state("unknown fullness", "yes")
		end
	end
	if requestpath == "/inv_use.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name then
			if d.spleen then
				used_spleen(d, 1, text:match([[<div id="effdiv">.-</div>]]))
			end
		else
			set_day_state("unknown spleen", "yes")
		end
	end
end

local function plunge_items(a, b, pwd)
	local aid = tonumber(str_to_table(get_item_data_by_name(a)).id)
	local bid = tonumber(str_to_table(get_item_data_by_name(b)).id)
	post_page("/knoll.php", { action = "combine", pwd = pwd, item1 = tostring(aid), item2 = tostring(bid), quantity = "1", ajax = "1" })
end

if path == "/beach.php" then
	if params.action == "woodencity" then
		if text:match("commence to getting that staff") then
			if get_session_state("staff of ed.requesting") == "" then
				set_session_state("staff of ed.requesting", "active")
				local pwd = get_session_state("pwd") -- careful!
				plunge_items("ancient amulet", "Eye of Ed", pwd)
				plunge_items("ancient amulet", "Staff of Fats", pwd)
				plunge_items("Staff of Fats", "headpiece of the Staff of Ed", pwd)
				plunge_items("Eye of Ed", "Staff of Ed, almost", pwd)
				text = post_page("/beach.php", params)
				set_session_state("staff of ed.requesting", "")
			end
		end
	end
end

mode = "automate"
dofile("scripts/ascension.lua")
dofile("scripts/nemesis-automation.lua")
dofile("scripts/ascension-automation.lua")
dofile("scripts/spading-automation.lua")

return text
